import pyglet, random
from pyglet.window import key
from tools import info_X_Y
from sprites import game_Logo, map_Block
from graphics2d import draw_rect

class numberWindow(pyglet.window.Window):
    def __init__(self, *args, **kwargs):
        super(numberWindow, self).__init__(800, 600, caption="Hello World")
        
        self.batch = pyglet.graphics.Batch()

        self.start_x = 2
        self.start_y = 2
        self.hit = 0
        self.flyer_alive = 0
        
        self.mouse_label = pyglet.text.Label('Kill H1N1',
            font_name='Time New Roman',
            font_size=20,
            x = 650, y = 375, anchor_x="left", anchor_y="top", batch=self.batch)
        
        self.mouse_label = pyglet.text.Label('mouse here',
            font_name='Time New Roman',
            font_size=10,
            x = 650, y = 300, anchor_x="left", anchor_y="top", batch=self.batch)
        
        self.hit_label = pyglet.text.Label('hit: ',
            font_name='Time New Roman',
            font_size=10,
            x = 650, y = 275, anchor_x='left', anchor_y='top', batch=self.batch)
        
        self.flyer_alive_label = pyglet.text.Label('viruses alive: ',
            font_name='Time New Roman',
            font_size=10,
            x = 650, y = 250, anchor_x='left', anchor_y='top', batch=self.batch)
        
        # load image.
        self.mouse_image = pyglet.image.load('static/shoes.gif')
        self.mouse_get_off_image = pyglet.image.load('static/kill.gif')
        
        self.cursor = pyglet.window.ImageMouseCursor(self.mouse_image, 45, 62)
        self.get_off_cursor = pyglet.window.ImageMouseCursor(self.mouse_get_off_image, 45, 62)
        self.set_mouse_cursor(self.cursor)
        
        self.logo_sprite = game_Logo(batch=self.batch)
        self.xy = info_X_Y(self.batch)
        self.m_b = []
        self.create_Map_Block()

    
    def create_Map_Block(self):
        point_x_y = self.xy.point_x_y_list
#        label_text_x_y = self.xy.label_text_list
        for n in range(0, len(point_x_y)):
            self.xy.package_screen_list(self.start_x, self.start_y)
#            mb = map_Block(image=self.xy.get_grass_images_list_from_x_y(x, y) ,batch=self.batch)
            mb = map_Block(batch=self.batch)
            mb.x = point_x_y[n][0]
            mb.y = point_x_y[n][1]
            i = random.randint(0,3)
#            mb.image = mb.grass[i]
            mb.label.x = mb.x + 100
            mb.label.y = mb.y + 100
            mb.label.text = self.xy.package_list[n].label             
            self.m_b.append(mb)
        
    def on_draw(self):
        self.clear()
        self.batch.draw()
        for p in self.xy.point_x_y():
            draw_rect(p[0],p[1],200,200, filled=False)
        s_m_p = self.xy.small_point_x_y_list
        for n in range(0, len(s_m_p)):
            if self.xy.map_block_obj_list[n].flyer.alive:
                draw_rect(s_m_p[n][0], s_m_p[n][1], 25, 25, filled=True)
                self.xy.map_block_obj_list[n].flyer.draw()
            else:
                draw_rect(s_m_p[n][0], s_m_p[n][1], 25, 25, filled=False)
        draw_rect(610 + (self.start_x * 25), 410 + (self.start_y * 25), 75,75, line_width=5, filled=False)
    
    # something key handler will re-add under here again.
    def on_key_press(self, symbol, modifiers):
        if symbol == key.ESCAPE:
            self.has_exit = True
        if symbol == key.W:
            if self.start_y < 4: self.start_y +=1
        if symbol == key.S:
            if self.start_y > 0: self.start_y -=1
        if symbol == key.D:
            if self.start_x < 4: self.start_x +=1
        if symbol == key.A:
            if self.start_x > 0: self.start_x -=1
    
    def on_mouse_press(self, x, y, button, modifiers):
        self.set_mouse_cursor(self.get_off_cursor)
        for o in self.xy.map_block_obj_list:
            if o.flyer and self.hit_test(x, y, o.flyer):
                self.mouse_label.text = 'hit'
                o.flyer.alive = False
                self.hit += 1
                self.flyer_alive -= 1
                self.hit_label.text = 'hit: %s' %self.hit
                self.flyer_alive_label.text = 'flyer_alive: %s' %self.flyer_alive
    
    def on_mouse_motion(self, x, y, dx, dy):
        self.set_mouse_cursor(self.cursor)
        self.mouse_label.text = 'x=%s, y=%s' %(x, y)
    
    def on_mouse_release(self, x, y, button, modifiers):
        self.set_mouse_cursor(self.cursor)
        
    def hit_test(self, x, y, s):
        return (0 < x - s.x < s.width and
                0 < y - s.y < s.height)
    
    def update(self, dt):
        for n in range(0, len(self.xy.point_x_y_list)):
            get_n = self.xy.package_screen_list(start_x=self.start_x, start_y=self.start_y)
            self.m_b[n].label.text = self.xy.package_list[n].label
            self.m_b[n].image = self.xy.package_list[n].block_image
            
        for n in range(0, 49):
#            if random.randint(0,1000) <= (self.flyer_alive / 50) + 1:
            if random.randint(0,3000) <= 1:
                if not self.xy.map_block_obj_list[n].flyer.alive:
                    self.xy.map_block_obj_list[n].flyer.alive = True
                    self.flyer_alive += 1        